package cn.iocoder.yudao.module.pms.service.laswell;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.laswell.vo.LasWellPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.laswell.vo.LasWellSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.laswell.LasWellDO;
import cn.iocoder.yudao.module.pms.dal.mysql.laswell.LasWellMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.LAS_WELL_NOT_EXISTS;

/**
 * 数字油藏LAS数据文件-井信息 Service 实现类
 *
 * @author ruiqi
 */
@Service
@Validated
public class LasWellServiceImpl implements LasWellService {

    @Resource
    private LasWellMapper lasWellMapper;

    @Override
    public Long createLasWell(LasWellSaveReqVO createReqVO) {
        // 插入
        LasWellDO lasWell = BeanUtils.toBean(createReqVO, LasWellDO.class);
        lasWellMapper.insert(lasWell);
        // 返回
        return lasWell.getId();
    }

    @Override
    public void updateLasWell(LasWellSaveReqVO updateReqVO) {
        // 校验存在
        validateLasWellExists(updateReqVO.getId());
        // 更新
        LasWellDO updateObj = BeanUtils.toBean(updateReqVO, LasWellDO.class);
        lasWellMapper.updateById(updateObj);
    }

    @Override
    public void deleteLasWell(Long id) {
        // 校验存在
        validateLasWellExists(id);
        // 删除
        lasWellMapper.deleteById(id);
    }

    private void validateLasWellExists(Long id) {
        if (lasWellMapper.selectById(id) == null) {
            throw exception(LAS_WELL_NOT_EXISTS);
        }
    }

    @Override
    public LasWellDO getLasWell(Long id) {
        return lasWellMapper.selectById(id);
    }

    @Override
    public PageResult<LasWellDO> getLasWellPage(LasWellPageReqVO pageReqVO) {
        return lasWellMapper.selectPage(pageReqVO);
    }

}